from Object import *
from Cube import *
from OpenGL.GL import *
from OpenGL.GLU import *
from pygame.locals import * 
from LoadMesh import *


def button_click():
    print("clicked!")



clock = pygame.time.Clock()
fps = 30

pygame.init()
screen_width = 800
screen_height = 600
pygame.display.set_caption('OpenGL in Python')
screen = pygame.display.set_mode((screen_width, screen_height),
                                 DOUBLEBUF | OPENGL)

done = False
white = pygame.Color(255, 255, 255)
objects_3d = []
objects_2d = []

cube = Object("Cube")
cube.add_component(Transform((0, 0, -5), (1, 0, 1, 0)))
cube.add_component(LoadMesh(GL_LINE_LOOP, "models/teapot.obj"))
cube.add_component(Cube(GL_POLYGON))
objects_3d.append(cube)

white = pygame.Color(255, 255, 255)
green = pygame.Color(0, 255, 0)
blue = pygame.Color(0, 0, 255)

button1 = Object("Button")
button1.add_component(Button(screen, (0, 0), 100, 50, green, blue, white, button_click))
objects_2d.append(button1)

clock = pygame.time.Clock()
fps = 30

mouse_down = False
last_mouse_pos = (0, 0)



def set_2d():
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluOrtho2D(0, screen.get_width(), 0,
               screen.get_height())
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    glViewport(0, 0, screen.get_width(),
               screen.get_height())



def set_3d():
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(60, (screen_width / screen_height),
                   0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    glViewport(0, 0, screen.get_width(),
               screen.get_height())
    glEnable(GL_DEPTH_TEST)



while not done:
    events = pygame.event.get()
    for event in events:
        if event.type == pygame.QUIT:
            done = True
        elif event.type == MOUSEBUTTONDOWN and \
                           event.button == 1:
            mouse_down = True
            last_mouse_pos = pygame.mouse.get_pos()
        elif event.type == MOUSEBUTTONUP and \
                           event.button == 1:
            mouse_down = False
        elif event.type == MOUSEMOTION and \
            mouse_down is True:
            last_mouse_pos = pygame.mouse.get_pos()
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_LEFT:
                trans: Transform = cube.get_component(Transform)
                if trans is not None:
                    pass
                    # trans.move_x(-0.1) #przesuwamy
   
            elif event.key == pygame.K_RIGHT:
                trans: Transform = cube.get_component(Transform)
                if trans is not None:
                    pass
                    # trans.move_x(0.1) #przesuwamy

            elif event.key == pygame.K_UP:
                trans: Transform = cube.get_component(Transform)
                if trans is not None:
                    pass
                    # trans.move_y(0.1) #przesuwamy
   
            elif event.key == pygame.K_DOWN:
                trans: Transform = cube.get_component(Transform)
                if trans is not None:
                    pass
                    # trans.move_y(-0.1) #przesuwamy
    
    keys = pygame.key.get_pressed()
    if keys[pygame.K_LEFT]:
        trans.move_x(-0.1)
    if keys[pygame.K_RIGHT]:
        trans.move_x(0.1)
    if keys[pygame.K_UP]:
        trans.move_y(0.1)
    if keys[pygame.K_DOWN]:
        trans.move_y(-0.1)

    glPushMatrix()
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)

    set_3d()
    for o in objects_3d:
        o.update(events)

    set_2d()
    for o in objects_2d:
        o.update(events)

    glPopMatrix()
    pygame.display.flip()
    clock.tick(fps)

pygame.quit()