from Mesh3D import *
from Transform import *
from OpenGL.GL import *
from Button import *
from Grid import *

class Object:
    def __init__(self, obj_name):
        self.name = obj_name
        self.components = []

    def add_component(self, component):
        if isinstance(component, Transform):
            self.components.insert(0, component)
        else:
            self.components.append(component)

    def update(self, events):
        glPushMatrix()            # zapamiętaj bieżącą macierz transformacji
        for c in self.components:
            if isinstance(c, Transform):
                pos = c.get_position()
                glTranslatef(pos.x, pos.y, pos.z)

            if isinstance(c, Mesh3D):
                rot = self.components[0].get_rotation()
                rot_speed = self.components[0].get_rotation_speed()
                angle = self.components[0].get_angle()
                newAngle = angle + rot_speed
                self.components[0].set_angle(newAngle)
                glRotatef(newAngle, rot.x, rot.y, rot.z)
                c.draw()
            if isinstance(c, Grid):
                c.draw()
            if isinstance(c, Button): # obsługa komponentu Button
                c.draw(events)
        glPopMatrix()             # przywróć macierz (usuń transformacje obiektu)

    def get_component(self, class_type):
        for c in self.components:
            if type(c) is class_type:
                return c
        return None