from Object import *
from Cube import *
from OpenGL.GL import *
from OpenGL.GLU import *
from pygame.locals import * 
from Grid import *


def button_click():
    print("clicked!")



clock = pygame.time.Clock()
fps = 30

pygame.init()
screen_width = 800
screen_height = 600
pygame.display.set_caption('OpenGL in Python')
screen = pygame.display.set_mode((screen_width, screen_height),
                                 DOUBLEBUF | OPENGL)

done = False
white = pygame.Color(255, 255, 255)
objects_3d = []
objects_2d = []

cube = Object("Cube")
cube.add_component(Transform((0, 0, -5), (1, 0, 1, 0)))
cube.add_component(Cube(GL_POLYGON))
objects_3d.append(cube)

cube2 = Object("Cube")
cube2.add_component(Transform((0, 2, -10), (1, 0, 1, 0)))
cube2.add_component(Cube(GL_POLYGON))
objects_3d.append(cube2)

grid = Object("Grid")
grid.add_component(Transform((0, 0, -5), (1, 0, 1, 0)))
grid.add_component(Grid(0.5, 8, (0, 0, 255)))
objects_3d.append(grid)

clock = pygame.time.Clock()
fps = 30

mouse_down = False
last_mouse_pos = (0, 0)



def set_2d():
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluOrtho2D(0, screen.get_width(), 0,
               screen.get_height())
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    glViewport(0, 0, screen.get_width(),
               screen.get_height())



def set_3d():
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(60, (screen_width / screen_height),
                   0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    glViewport(0, 0, screen.get_width(),
               screen.get_height())
    glEnable(GL_DEPTH_TEST)



while not done:
    events = pygame.event.get()
    trans: Transform = cube.get_component(Transform)
    trans2: Transform = cube2.get_component(Transform)
    for event in events:
        if event.type == pygame.QUIT:
            done = True
        elif event.type == MOUSEBUTTONDOWN and \
                           event.button == 1:
            mouse_down = True
            last_mouse_pos = pygame.mouse.get_pos()
        elif event.type == MOUSEBUTTONUP and \
                           event.button == 1:
            mouse_down = False
        elif event.type == MOUSEMOTION and \
            mouse_down is True:
            last_mouse_pos = pygame.mouse.get_pos()
        elif event.type == pygame.KEYDOWN:
            if event.key == K_SPACE:
                trans.move(pygame.Vector3(1, 1, 0))
                trans2.move(pygame.Vector3(1, 1, 0) * -2)
                print("dlugosc mniej oddalonego", trans.length())
                print("dlugosc bardziej oddalonego", trans2.length())
            if event.key == pygame.K_LEFT:
                if trans is not None:
                    trans.move(pygame.Vector3(-1, -1, 0))
                    trans2.move(pygame.Vector3(-1, -1, 0) * -2)
                    # trans.move_x(-0.1) #przesuwamy
   
            elif event.key == pygame.K_RIGHT:
                if trans is not None:
                    pass
                    # trans.move_x(0.1) #przesuwamy

            elif event.key == pygame.K_UP:
                if trans is not None:
                    pass
                    # trans.move_y(0.1) #przesuwamy
   
            elif event.key == pygame.K_DOWN:
                if trans is not None:
                    pass
                    # trans.move_y(-0.1) #przesuwamy
    
    # keys = pygame.key.get_pressed()
    # if keys[pygame.K_LEFT]:
    #     #trans.move_x(-0.1)
    # if keys[pygame.K_RIGHT]:
    #     trans.move_x(0.1)
    # if keys[pygame.K_UP]:
    #     trans.move_y(0.1)
    # if keys[pygame.K_DOWN]:
    #     trans.move_y(-0.1)

    glPushMatrix()
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)

    set_3d()
    for o in objects_3d:
        o.update(events)

    set_2d()
    for o in objects_2d:
        o.update(events)

    glPopMatrix()
    pygame.display.flip()
    clock.tick(fps)

pygame.quit()